Bug 627373 - BackupPC 3.2.1 available
Summary: BackupPC 3.2.1 available
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: BackupPC
Version: 15
Hardware: All
OS: Linux
low
medium
Target Milestone: ---
Assignee: Bernard Johnson
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On: 720085 720086
Blocks:
TreeView+ depends on / blocked
 
Reported: 2010-08-25 20:57 UTC by Ray Todd Stevens
Modified: 2011-10-27 18:01 UTC (History)
4 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2011-08-09 01:38:10 UTC


Attachments (Terms of Use)
Updated spec for 3.2.1 (10.25 KB, application/octet-stream)
2011-05-02 18:14 UTC, Richard Shaw
no flags Details
Patch configure.pl so it doesn't look for the bundled perl libraries. (420 bytes, patch)
2011-05-02 18:14 UTC, Richard Shaw
no flags Details | Diff
Spec git diff (643 bytes, patch)
2011-07-31 17:37 UTC, Richard Shaw
no flags Details | Diff
SELinux additions to the spec file (624 bytes, patch)
2011-08-08 13:26 UTC, Richard Shaw
no flags Details | Diff

Description Ray Todd Stevens 2010-08-25 20:57:36 UTC
The new version 3.2.0 is now out as production.   We need to look into upgrading the version in fedora.

Comment 1 Johan Cwiklinski 2010-08-25 22:04:54 UTC
I already take a look at this ; but 3.2 version comes with 2 perl modules that must be packaged separately (according to Fedora's rules).

I do not have time now to handle new packages unfortunately. If someone wish to contribute...

Comment 2 Ray Todd Stevens 2010-08-26 02:30:28 UTC
What does it come with that are a problem?

Comment 3 Johan Cwiklinski 2010-08-26 05:44:11 UTC
See packaging guidelines: http://fedoraproject.org/wiki/Packaging:No_Bundled_Libraries

Comment 4 Ray Todd Stevens 2010-10-01 20:54:32 UTC
Which specific libraries are bundled that are the problem.   I was going to see if I could find them already bundled by someone else.

Comment 5 Richard Shaw 2010-11-09 19:36:21 UTC
(In reply to comment #0)
> The new version 3.2.0 is now out as production.   We need to look into
> upgrading the version in fedora.

Johan,

Can you be more specific? Reviewing the documentation for 3.2.0 I don't see any additional Perl module requirements.

Comment 6 Ray Todd Stevens 2010-11-09 21:48:05 UTC
Yeah I can't find this out either.

Comment 7 Johan Cwiklinski 2010-11-10 07:08:50 UTC
Sorry, I did not see comment #4...

The two perl modules I was talking about are not requirements for 3.2.0 ; they are shipped in the archive.

They stand in "/BackupPC-3.2.0/lib/Net/FTP/" :
- AutoReconnect.pm
- RetrHandle.pm

I already have worked on those two libs ; but one does not build completely (do not remember which one - but as far as I remember ; that fails on 'make test'). You can find the two specfiles:
http://odysseus.x-tnd.be/fedora/BackupPC/3.2.0_modules/

Comment 8 Johan Cwiklinski 2010-11-10 07:11:37 UTC
Someone has posted recently on the BackupPC mailing list regarding this module that does not pass tests:
http://sourceforge.net/mailarchive/forum.php?thread_name=4CDA1A8C.9040901%40vpac.org&forum_name=backuppc-users

Comment 9 Richard Shaw 2011-05-02 14:39:02 UTC
(In reply to comment #7)
> Sorry, I did not see comment #4...
> 
> The two perl modules I was talking about are not requirements for 3.2.0 ; they
> are shipped in the archive.
> 
> They stand in "/BackupPC-3.2.0/lib/Net/FTP/" :
> - AutoReconnect.pm
> - RetrHandle.pm
> 
> I already have worked on those two libs ; but one does not build completely (do
> not remember which one - but as far as I remember ; that fails on 'make test').
> You can find the two specfiles:
> http://odysseus.x-tnd.be/fedora/BackupPC/3.2.0_modules/

I believe it was Net::FTP::RetrHandle because I looked it up on cpantesters and found that it failed on almost every system including all linux systems. 

That was several months ago now I can't find that it even exists on Cpantesters. But it is still showing on perl.org. 

Can we just ship BackupPC without FTP support? I know I'm not using it.

Comment 10 Richard Shaw 2011-05-02 18:14:21 UTC
Created attachment 496327 [details]
Updated spec for 3.2.1

Updated spec for 3.2.1. 
This removes the 2 perl modules in %prep and applies a patch to configure.pl so it doesn't look for them.

I also tried adding a Requires for rrdtool-perl to see if the graphs will work but that may not be enough by itself.

Comment 11 Richard Shaw 2011-05-02 18:14:54 UTC
Created attachment 496328 [details]
Patch configure.pl so it doesn't look for the bundled perl libraries.

Comment 12 Richard Shaw 2011-05-02 20:22:07 UTC
(In reply to comment #10)
> Created attachment 496327 [details]
> Updated spec for 3.2.1
> 
> Updated spec for 3.2.1. 
> This removes the 2 perl modules in %prep and applies a patch to configure.pl so
> it doesn't look for them.
> 
> I also tried adding a Requires for rrdtool-perl to see if the graphs will work
> but that may not be enough by itself.

Forgot to add, commented out the TopDir patch as it doesn't appear to be necessary anymore. 

Took a chance and built (under mock) and installed and so far so good. Did a full backup of one of my hosts.

Comment 13 Richard Shaw 2011-05-03 15:22:31 UTC
(In reply to comment #12)
> (In reply to comment #10)
> > I also tried adding a Requires for rrdtool-perl to see if the graphs will work
> > but that may not be enough by itself.

Turns out that's a Debian/Ubuntu hack, oh well. Sure looked nice.

Comment 14 Bug Zapper 2011-06-01 10:24:49 UTC
This message is a reminder that Fedora 13 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 13.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '13'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 13's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 13 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 15 Richard Shaw 2011-06-01 12:52:20 UTC
This bug should stay open. 

I have provided a "fix" but have not gotten any feedback.

Comment 16 Ray Todd Stevens 2011-06-01 13:40:01 UTC
OK I had not caught that this was fixed or attempted to be fixed.   I will get this server upgraded to 15 and try it out in the next week or so.

Comment 17 Richard Shaw 2011-06-01 14:01:30 UTC
I've got packages up on fedorapeople.org if you're interested.

http://hobbes1069.fedorapeople.org/BackupPC/

Comment 18 Richard Shaw 2011-06-14 18:34:18 UTC
Have you had a chance to try my package or build your own for testing?

Comment 19 Bernard Johnson 2011-07-07 04:25:50 UTC
Unless I'm mistaken, your patch breaks FTP backups (everything looks fine in build/install but trying ftp backup will fail?).  I don't think we can ship it that way.

Probably the easiest thing is to try to get the bundled libraries in Fedora.

Comment 20 Richard Shaw 2011-07-07 13:39:08 UTC
Yes, unfortunately it has to break FTP backups. 

I would like to see the perl modules packaged for Fedora but I don't know how that can happen since one of the modules, Net::FTP::RetrHandle, doesn't build and fails its tests. 

See: http://static.cpantesters.org/distro/N/Net-FTP-RetrHandle.html

I've have repeatedly asked on the BackupPC mailing lists (user and devel) why they use a module that's so broken but I have yet to get an answer. It has really been quite frustrating to put it mildly. 

After that I gave up and yanked the modules. 

Thanks,
Richard

Comment 21 Bernard Johnson 2011-07-09 04:55:53 UTC
I added review requests for both required packages (bz #720085, bz #720086).  If anyone is has a sponsor and can review them, I would appreciate it.

Comment 22 Bernard Johnson 2011-07-09 05:51:41 UTC
Here is a scratch build for F15 i686/x86_64 if you want to do some testing.  You'll have to use --nodeps to install and bypass the two FTP related perl module dependencies until they are available.

http://koji.fedoraproject.org/koji/taskinfo?taskID=3188005

There are a lot of changes, so chance of breakage is high - back up your configuration.

- v 3.2.1
- add lower case script URL alias for typing impaired
- cleanup selinux macros
- spec cleanup
- make samba dependency on actual files required to EL5 can use samba-client
  or samba3x-client (bz #667479)
- unbundle perl(Net::FTP::AutoReconnect) and perl(Net::FTP::RetrHandle)
- remove old patch that is no longer needed
- attempt to make sure $Conf{TopDir} is listed in updatedb PRUNEPATHS,
  otherwise at least generate a warning on statup (bz #554491)
- move sockets to /var/run (bz #719499)
- add support for systemd starting at F16 (bz #699441)
- patch to move pid dir under /var/run
- minor spec cleanup
- unbundle Net::FTP::*
- add support for tmpfiles.d

Comment 23 Richard Shaw 2011-07-11 00:29:17 UTC
After updating and trying to start the service I got the following error:

# service backuppc start
Starting BackupPC:                                         [  OK  ]
/etc/init.d/backuppc: line 33: [: missing `]'

Adding a space between the "1" and the "]" on line 33 fixed it for me.

Richard

Comment 24 Richard Shaw 2011-07-12 00:28:01 UTC
Just noticed a sealert related to BackupPC since upgrading to the koji version (I rebuilt the srpm in mock for F14:


SELinux is preventing /usr/bin/perl from write access on the sock_file BackupPC.sock.

*****  Plugin catchall (100. confidence) suggests  ***************************

If you believe that perl should be allowed write access on the BackupPC.sock sock_file by default.
Then you should report this as a bug.
You can generate a local policy module to allow this access.
Do
allow this access for now by executing:
# grep BackupPC_Admin. /var/log/audit/audit.log | audit2allow -M mypol
# semodule -i mypol.pp

Additional Information:
Source Context                unconfined_u:system_r:httpd_t:s0
Target Context                unconfined_u:object_r:var_run_t:s0
Target Objects                BackupPC.sock [ sock_file ]
Source                        BackupPC_Admin.
Source Path                   /usr/bin/perl
Port                          <Unknown>
Host                          hobbes.localdomain
Source RPM Packages           perl-5.12.3-143.fc14
Target RPM Packages           
Policy RPM                    selinux-policy-3.9.7-43.fc14
Selinux Enabled               True
Policy Type                   targeted
Enforcing Mode                Permissive
Host Name                     hobbes.localdomain
Platform                      Linux hobbes.localdomain 2.6.38.8-31.fc14.x86_64
                              #1 SMP Tue Jun 7 09:47:54 CDT 2011 x86_64 x86_64
Alert Count                   2
First Seen                    Sun 10 Jul 2011 07:27:54 PM CDT
Last Seen                     Sun 10 Jul 2011 08:26:23 PM CDT
Local ID                      59595d57-b90e-4283-8075-13cddba51894

Raw Audit Messages
type=AVC msg=audit(1310347583.36:78172): avc:  denied  { write } for  pid=13095 comm="BackupPC_Admin." name="BackupPC.sock" dev=dm-3 ino=10879680 scontext=unconfined_u:system_r:httpd_t:s0 tcontext=unconfined_u:object_r:var_run_t:s0 tclass=sock_file


type=SYSCALL msg=audit(1310347583.36:78172): arch=x86_64 syscall=connect success=yes exit=0 a0=3 a1=233bbe0 a2=6e a3=0 items=0 ppid=12349 pid=13095 auid=500 uid=48 gid=489 euid=489 suid=489 fsuid=489 egid=489 sgid=489 fsgid=489 tty=(none) ses=488 comm=BackupPC_Admin. exe=/usr/bin/perl subj=unconfined_u:system_r:httpd_t:s0 key=(null)

Hash: BackupPC_Admin.,httpd_t,var_run_t,sock_file,write

audit2allow

#============= httpd_t ==============
allow httpd_t var_run_t:sock_file write;

audit2allow -R

#============= httpd_t ==============
allow httpd_t var_run_t:sock_file write;

Comment 25 Bernard Johnson 2011-07-12 03:28:24 UTC
See if this fixes it for you.

http://koji.fedoraproject.org/koji/taskinfo?taskID=3192895

Comment 26 Richard Shaw 2011-07-12 13:39:38 UTC
I've installed the package and restarted my server, I'll check tonight if there's any sealerts. 

BTW, the /etc/init.d/backuppc still had the problem on line 33.

Thanks,
Richard

Comment 27 Richard Shaw 2011-07-31 14:44:52 UTC
Ok, I'm still getting selinux alerts... I thought they had stopped because they were fixed but apparently when I reinstalled for 3.2.1 it turned off the service so it hasn't been running since 7/14....

Comment 28 Richard Shaw 2011-07-31 17:37:49 UTC
Created attachment 516025 [details]
Spec git diff

Ok, suddenly had a though. I made BackupPC cause an sealert and then did the audit2allow per the troubleshooter, but instead of applying it I compared the output to what's in the spec file and added it.

So far I've clicked on about every option in the CGI interface and did backups and archived them and no more alerts. Archiving was broken until I did this.

Comment 29 Fedora Update System 2011-08-08 04:08:14 UTC
BackupPC-3.2.1-1.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/BackupPC-3.2.1-1.el6

Comment 30 Bernard Johnson 2011-08-08 04:09:53 UTC
It was unclear to me which version you were running (I did make some changes to selinux configuration in between test versions).

I'm going to push the new version to get it in other peoples hands.  Please make sure you are using it and if you see selinux errors, open another bug and I'll start working on those changes.

Comment 31 Fedora Update System 2011-08-08 04:12:59 UTC
BackupPC-3.2.1-1.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/BackupPC-3.2.1-1.el5

Comment 32 Fedora Update System 2011-08-08 04:13:55 UTC
BackupPC-3.2.1-1.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/BackupPC-3.2.1-1.fc15

Comment 33 Fedora Update System 2011-08-08 04:14:46 UTC
BackupPC-3.2.1-1.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/BackupPC-3.2.1-1.fc14

Comment 34 Richard Shaw 2011-08-08 13:26:56 UTC
Created attachment 517213 [details]
SELinux additions to the spec file

No, it does not appear the SELinux policy updates are in the current package. I just downloaded the F15 SRPM. Here's a diff compared to mine.

Comment 35 Fedora Update System 2011-08-09 01:37:41 UTC
BackupPC-3.2.1-1.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 36 Fedora Update System 2011-08-09 01:39:08 UTC
BackupPC-3.2.1-1.fc15 has been pushed to the Fedora 15 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 37 Fedora Update System 2011-08-16 20:56:06 UTC
BackupPC-3.2.1-1.el6 has been pushed to the Fedora EPEL 6 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 38 Fedora Update System 2011-08-16 21:08:23 UTC
BackupPC-3.2.1-1.el5 has been pushed to the Fedora EPEL 5 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 39 Richard Shaw 2011-10-26 20:02:28 UTC
Someone from the BackuPC mailing list is having issues installing BackupPC on a RHEL 6.1 system, details below. Can you offer any advice? I want to make sure it's not due to the new perl modules.
---

 got back to this today.
I have been finding and installing each of the dependencies and then came to:

"perl-XML-RSS"

It had a dependency of: "perl-DateTime-Format-Mail"
I found that and tried installing it and got:
"           Requires: perl(DateTime) >= 0.1705
           Installed: 1:perl-DateTime-0.5300-1.el6.x86_64 (@rhel-6-server-rpms)
               perl(DateTime) = 0.53
"
I looked this up and it seems to be a dilemma, I've got a newer version than what it seems to require however it won't install.
This is the last thing BackupPC seems to be complaining about, if I can figure this out I can proceed with the installation.
I don't remember this happening on my test system, but even though it was the same OS it was a different environment.
Ideas about getting around this please?

Rick Bastedo



On Fri, Oct 21, 2011 at 9:22 AM, Les Mikesell <lesmikesell@gmail.com> wrote:
On Fri, Oct 21, 2011 at 10:54 AM, Rick Bastedo <rbastedo@gmail.com> wrote:
> Well I've been told we are using backuppc, so that's why I am using it.
> That's the way it works where I work.

Perhaps if you explained the details of what you have to do to get
something on to the DPM system someone could help with making backuppc
do it for you.

> I tried installing from EPEL.
>
> You said:
> "You should probably configure the EPEL yum repository and use 'yum
> install backuppc' to do the install.  The way yum works, it will
> install any needed dependencies so it won't matter much what you
> installed initially.
> https://fedoraproject.org/wiki/EPEL6-FAQ#How_do_I_use_it.3F"
>
>
> Here's the error I got when trying:
>
> yum install
> http://mirror.pnl.gov/epel/6/x86_64/BackupPC-3.2.1-6.el6.x86_64.rpm
>>(blah blah blah --> Processing Dependencies... etc)
> ... ... ... ...
> --> Finished Dependency Resolution
> Error: Package: BackupPC-3.2.1-6.el6.x86_64 (/BackupPC-3.2.1-6.el6.x86_64)
>            Requires: perl(Net::FTP::RetrHandle)
> Error: Package: BackupPC-3.2.1-6.el6.x86_64 (/BackupPC-3.2.1-6.el6.x86_64)
>            Requires: perl(XML::RSS)
> Error: Package: BackupPC-3.2.1-6.el6.x86_64 (/BackupPC-3.2.1-6.el6.x86_64)
>            Requires: perl(Time::ParseDate)
> Error: Package: BackupPC-3.2.1-6.el6.x86_64 (/BackupPC-3.2.1-6.el6.x86_64)
>            Requires: perl(Archive::Zip)
> Error: Package: BackupPC-3.2.1-6.el6.x86_64 (/BackupPC-3.2.1-6.el6.x86_64)
>            Requires: perl-Time-modules
> Error: Package: BackupPC-3.2.1-6.el6.x86_64 (/BackupPC-3.2.1-6.el6.x86_64)
>            Requires: perl(File::RsyncP)
> Error: Package: BackupPC-3.2.1-6.el6.x86_64 (/BackupPC-3.2.1-6.el6.x86_64)
>            Requires: perl(Net::FTP::AutoReconnect)
>
> I added EPEL as a repository when I installed and yes this is a registered
> RHEL 6.1 install.
> I make no claim at being adept in Linux, so don't fear offending me by
> pointing out obvious idiocy on my part.

I've only done it on CentOS where yum is the native update tool and is
configured to resolve/install dependencies automatically, so it 'just
works'.   Maybe the RHEL yum setup is different.  Can you 'yum
install' each of those required packages (enclose the names in single
quotes, or change the style to look like perl-File-RsyncP)?

--
 Les Mikesell
   lesmikesell@gmail.com

Comment 40 Bernard Johnson 2011-10-27 01:31:30 UTC
1.  Please don't hijack bugs for different errors.  It's much cleaner opening separate bugs which I can then mark duplicate or resolve differently.  This bug is already closed.  In general, nobody follows closed bugs.

2.  Thank you for providing this kind of help and monitoring the upstream mailing list.  I'm only able to periodically monitor it and this kind of feedback is important.

3.  Have a look at this and see if it's the problem:  https://bugzilla.redhat.com/show_bug.cgi?id=740276

4.  If that is the problem, open another bug against the BackupPC package that specifies that a README.EPEL needs to be created to document this situation.

Comment 41 Richard Shaw 2011-10-27 13:54:46 UTC
Sorry about that! I thought that if it was directly related to the update then it was appropriate. 

I also didn't want to open a new bug if it turned out to be a configuration problem on the end users side. I don't know why, opening a bug doesn't cost anything :)

As it turns out that was the case. He had the expectation (and so would I) that when he configured EPEL during install that it would be available after install. Apparently this is not the case. After adding the appropriate yum configuration BackupPC installed fine.

Thanks,
Richard

Comment 42 Bernard Johnson 2011-10-27 15:07:57 UTC
(In reply to comment #41)
> opening a bug doesn't cost anything :)

Exactly!

> As it turns out that was the case. He had the expectation (and so would I) that
> when he configured EPEL during install that it would be available after
> install. Apparently this is not the case. After adding the appropriate yum
> configuration BackupPC installed fine.

Ok, great!  Please open a bug to add this documentation.  If it's happened twice already, it will happen again and deserves to be documented.

Thanks again for working with our end-users out there!

Comment 43 Richard Shaw 2011-10-27 18:01:38 UTC
Bug submitted. I submitted it in Fedora since that's where BackuPC lives, I hope that's the right way. Of course that prevented me from marking the version correctly since RHEL 6 is not an option.

https://bugzilla.redhat.com/show_bug.cgi?id=749627

Thanks,
Richard


Note You need to log in before you can comment on or make changes to this bug.